#!/usr/bin/python
# -*- coding: utf-8 -*-

import cv2.cv as cv

"""
The function cv.LoadImage loads an image from the specified file and returns the pointer to the loaded image. Currently the following file formats are supported:

    * Windows bitmaps - BMP, DIB
    * JPEG files - JPEG, JPG, JPE
    * Portable Network Graphics - PNG
    * Portable image format - PBM, PGM, PPM
    * Sun rasters - SR, RAS
    * TIFF files - TIFF, TIF

"""
original = cv.LoadImage("lena.jpg")
cv.NamedWindow("Original", 1)
cv.ShowImage("Original", original)
thumb = cv.CreateImage((int((original.width/5.0)),int(original.height/5.0)), 8, 3)
cv.Resize(original, thumb, cv.CV_INTER_LINEAR)
cv.NamedWindow("Thumbnail", 1)
cv.ShowImage("Thumbnail", thumb)
cv.SaveImage("lena_resized.jpg", thumb)
c = cv.WaitKey(0)
cv.DestroyWindow("Original")
cv.DestroyWindow("Thumbnail")
