#!/usr/bin/python
# -*- coding: utf-8 -*-
#

import cv2.cv as cv

# sourceImage1 = cv.LoadImage("obama.jpg")
# sourceImage2 = cv.LoadImage("osama.jpg")
sourceImage1 = cv.LoadImage("obama2.jpg")
sourceImage2 = cv.LoadImage("bush.jpg")
sourceImage1FaceWithMorphology = cv.CreateImage(cv.GetSize(sourceImage1), cv.IPL_DEPTH_8U, 3)
sourceImage2FaceWithMorphology = cv.CreateImage(cv.GetSize(sourceImage2), cv.IPL_DEPTH_8U, 3)
morphedImage = cv.CreateImage(cv.GetSize(sourceImage1), cv.IPL_DEPTH_8U, 3)

# set Labels
sourceImage1FaceMorphologyWindow = "Source Image 1"
sourceImage2FaceMorphologyWindow = "Source Image 2"
morphedImageWindow = "Morph: Space to Pause, q/ESC to quit"

# create and position windows
cv.NamedWindow(sourceImage1FaceMorphologyWindow)
cv.NamedWindow(sourceImage2FaceMorphologyWindow)
cv.NamedWindow(morphedImageWindow)
cv.MoveWindow(sourceImage1FaceMorphologyWindow, 0, 0)
cv.MoveWindow(sourceImage2FaceMorphologyWindow, 330, 0)
cv.MoveWindow(morphedImageWindow, 660, 0)

cv.Copy(sourceImage1, sourceImage1FaceWithMorphology)
cv.Copy(sourceImage2, sourceImage2FaceWithMorphology)

cv.ShowImage(sourceImage1FaceMorphologyWindow, sourceImage1FaceWithMorphology)
cv.ShowImage(sourceImage2FaceMorphologyWindow, sourceImage2FaceWithMorphology)

c = ""
while c != "q" and c !="\x1b":
    for count in range(100):
        cv.AddWeighted(sourceImage1FaceWithMorphology, 1-(count*0.01), sourceImage2FaceWithMorphology, count*0.01, 0, morphedImage)
        cv.ShowImage(morphedImageWindow, morphedImage)
        c = cv.WaitKey(100)
        if c == "q" or c =="\x1b":
            break
        elif c == " ":
            c = cv.WaitKey()
    if c != "q" and c !="\x1b":
        c = cv.WaitKey(1000)
    if c != "q" and c !="\x1b":
        for count in range(100):
            cv.AddWeighted(sourceImage2FaceWithMorphology, 1-(count*0.01), sourceImage1FaceWithMorphology, count*0.01, 0, morphedImage)
            cv.ShowImage(morphedImageWindow, morphedImage)
            c = cv.WaitKey(100)
            if c == " " or c =="\x1b":
                break
            elif c == " ":
                c = cv.WaitKey()
        if c != "q" and c !="\x1b":
            c = cv.WaitKey(1000)
    
cv.ReleaseImage(sourceImage1)
cv.ReleaseImage(sourceImage2)
cv.ReleaseImage(sourceImage1FaceWithMorphology)
cv.ReleaseImage(sourceImage2FaceWithMorphology)
cv.ReleaseImage(morphedImage)

cv.DestroyAllWindows()
