import cv2.cv as cv
import sys

def doPyrDownUp(im):
    # Best to make sure input image is divisible by two.
    #
    # assert(im.width%2 == 0 and im.height%2 == 0)
    out = cv.CreateImage((im.width/2, im.height/2), im.depth, im.nChannels)
    out2 = cv.CreateImage((im.width*2, im.height*2), im.depth, im.nChannels)
    # Do the pyrdown
    cv.PyrDown(im, out)
    # Do the pyrup
    cv.PyrUp(im, out2)
    return out, out2

if __name__ == '__main__':
    if len(sys.argv) == 1:
        filename = "sourceImage1.jpg"
    else:
        filename = sys.argv[1]
    img = cv.LoadImage(filename)
    cv.NamedWindow("Example4-in")
    cv.NamedWindow("Example4-out")
    cv.NamedWindow("Example4-out2")
    # Create a window to show our input image
    cv.ShowImage("Example4-in", img)
    # Create an image to hold the smoothed output
    #    
    ret, ret2 = doPyrDownUp(img)
    cv.ShowImage("Example4-out", ret)
    cv.ShowImage("Example4-out2", ret2)
    cv.WaitKey(0)
    cv.DestroyWindow("Example4-in")
    cv.DestroyWindow("Example4-out")
