import cv2.cv as cv

if __name__ == "__main__":
    #Init camera context with cam 0
    cam = cv.CaptureFromCAM(0)
    #Retrieve size of the camera images
    size = (int(cv.GetCaptureProperty(cam, cv.CV_CAP_PROP_FRAME_WIDTH)),
        int(cv.GetCaptureProperty(cam, cv.CV_CAP_PROP_FRAME_HEIGHT)))
    print size
    #Create a video writer
    writer = cv.CreateVideoWriter(
        "video.avi",
        0,
        24,
        size, 1)
    #Create a destination image for the flip method
    flipped_image = cv.CreateImage(size, cv.IPL_DEPTH_8U, 3)
    #Start the loop
    while True:
        #Query frame
        image = cv.QueryFrame(cam)
        #Flip image to simulate a mirror
        cv.Flip(image, flipped_image, 1)
        #Write the original image in the video
        cv.WriteFrame(writer, image)
        #Show the flipped image
        cv.ShowImage("Mirror", flipped_image)
        #We need this call to render the image window
        c = cv.WaitKey(33)
        if c == 27:
            break
