import cv2.cv as cv
capture=cv.CaptureFromCAM(0)
size = (int(cv.GetCaptureProperty(capture, cv.CV_CAP_PROP_FRAME_WIDTH)),
        int(cv.GetCaptureProperty(capture, cv.CV_CAP_PROP_FRAME_HEIGHT)))

""" CreateVideoWriter(filename, fourcc, fps, frame_size, is_color)
Parameters:	
    * filename (str) : Name of the output video file.
    * fourcc (int) : 4-character code of codec used to compress the frames.
    For example, CV_FOURCC('P','I','M,'1') is a MPEG-1 codec, 
    CV_FOURCC('M','J','P','G') is a motion-jpeg codec etc. 
    Under Win32 it is possible to pass -1 in order to choose 
    compression method and additional compression parameters from dialog. 
    Under Win32 if 0 is passed while using an avi filename it will create a 
    video writer that creates an uncompressed avi file.
    * fps (float) : Framerate of the created video stream.
    * frame_size (CvSize) : Size of the video frames.
    * is_color (int) : If it is not zero, the encoder will expect and encode color frames, otherwise it will work with grayscale frames (the flag is currently supported on Windows only).
"""
writer=cv.CreateVideoWriter("output.avi", 0, 24, size, 1)
count=0
while count<250:
    image=cv.QueryFrame(capture)
    cv.WriteFrame(writer, image)
    cv.ShowImage('Image_Window',image)
    cv.WaitKey(2)
    count+=1