import cv2.cv as cv
import sys, time
from pyrdownup_image import doPyrDownUp
if len(sys.argv)<2:
    image = cv.LoadImage("bush.jpg")
else:
    image = cv.LoadImage(sys.argv[1])
image = doPyrDownUp(image)[1]
cv.NamedWindow("Input", 1)
cv.ShowImage("Input", image)
skin = cv.CreateImage(cv.GetSize(image), 8, 1)
cv.Zero(skin)
# alternatively:
# skin2 = cv.CreateImage(cv.GetSize(image), 8, 3)
# cv.Zero(skin2)
skin2 = cv.CloneImage(image)

w = image.width
h = image.height
t = time.time()
points = []
for i in range(w):
    for j in range(h):
        # y = YCrCbData[i, j, 0];
        y = cv.Get2D(image, j, i)[2]
        # cr = YCrCbData[i, j, 1];
        cr = cv.Get2D(image, j, i)[1]
        # cb = YCrCbData[i, j, 2];
        cb = cv.Get2D(image, j, i)[0]
        cb -= 109
        cr -= 152
        x1 = int((819 * cr - 614 * cb) / 32 + 51)
        y1 = int((819 * cr + 614 * cb) / 32 + 77)
        x1 = int(x1 * 41 / 1024)
        y1 = int(y1 * 73 / 1024)
        value = x1 * x1 + y1 * y1
        # print value,
        if (y < 100):
            # skinData[i, j, 0] = (value < 700) ? (byte)255 : (byte)0;
            # print "a",
            if value < 700:
               # print "b",
               cv.Set2D(skin, j, i, (255.0, 0.0, 0.0, 0.0))
               points.append((i, j))
        else:
            # skinData[i, j, 0] = (value < 850) ? (byte)255 : (byte)0;
            # print "c",
            if value < 1000:
               # print "d",
               cv.Set2D(skin, j, i, (255.0, 0.0, 0.0, 0.0))
               points.append((i, j))

cv.NamedWindow("Skin", 1)
cv.ShowImage("Skin", skin)
p = set(points)
p = list(p)
# print p
if p != []:
    storage = cv.CreateMemStorage(0)
    hull = cv.ConvexHull2(p, storage, cv.CV_CLOCKWISE, 1)
    cv.PolyLine(skin2, [hull], 1, cv.RGB(0,255,0), 1, cv.CV_AA)

"""
StructuringElementEx rect_6 = new StructuringElementEx(6, 6, 3, 3, Emgu.CV.CvEnum.CV_ELEMENT_SHAPE.CV_SHAPE_RECT);
CvInvoke.cvErode(skin, skin, rect_6, 1);
CvInvoke.cvDilate(skin, skin, rect_6, 2);
"""

t2 = time.time()-t
print "Skin detection in", t2, "seconds"
cv.NamedWindow("Output", 1)
cv.ShowImage("Output", skin2)
cv.WaitKey()
"""
//Code adapted from here
    // http://blog.csdn.net/scyscyao/archive/2010/04/09/5468577.aspx
    // Look at this paper for reference (Chinese!!!!!)
    // http://www.chinamca.com/UploadFile/200642991948257.pdf

    Image<Ycc,Byte> currentYCrCbFrame = Img.Convert<Ycc, Byte>();
    Image<Gray, Byte> skin = new Image<Gray, Byte>(Img.Width, Img.Height);

    int y, cr, cb, l, x1, y1, value;

    int rows = Img.Rows;
    int cols = Img.Cols;
    Byte[, ,] YCrCbData = currentYCrCbFrame.Data;
    Byte[, ,] skinData = skin.Data;

    for (int i = 0; i < rows; i++)
        for (int j = 0; j < cols; j++)
        {
            y = YCrCbData[i, j, 0];
            cr = YCrCbData[i, j, 1];
            cb = YCrCbData[i, j, 2];

            cb -= 109;
            cr -= 152;
            x1 = (819 * cr - 614 * cb) / 32 + 51;
            y1 = (819 * cr + 614 * cb) / 32 + 77;
            x1 = x1 * 41 / 1024;
            y1 = y1 * 73 / 1024;
            value = x1 * x1 + y1 * y1;
            if (y < 100)
                skinData[i, j, 0] = (value < 700) ? (byte)255 : (byte)0;
            else
                skinData[i, j, 0] = (value < 850) ? (byte)255 : (byte)0;

        }
    StructuringElementEx rect_6 = new StructuringElementEx(6, 6, 3, 3, Emgu.CV.CvEnum.CV_ELEMENT_SHAPE.CV_SHAPE_RECT);
    CvInvoke.cvErode(skin, skin, rect_6, 1);
    CvInvoke.cvDilate(skin, skin, rect_6, 2);
    return skin;
"""
